' Jean-Claude Berger, march 2007, version 1.02
' CopyPhotos.vbs

' Script to copy pictures from a memory card userd with a digital camera.
' Will take all files (but not folders themselves) from all removable disks
' having a DCIM\whatever_subfolder folder (cameras create them)
' and copy them to the destination folder given as an argument 
'(or My pictures\New Pictures if none given).
' Wil NOT erease files if they are already present on destination folder
' nor will delete them from source.

' DISCLAIMER: This program is NOT supported (in other words, I will NOT answer 
' any question about it) and there is NO WARRANTY of any kind attached to it.
' If you lose all your data or your job, if your children, you wife and your dog
' hate you because you used it, IT'S YOUR PROBLEM, NOT MINE.
' The simple fact to think about downloading it makes up acceptance of those terms.

' NOTE IMPORTANTE: CE PROGRAMME EST GRATUIT ET EN TELECHARGEMENT
' LIBRE. MAIS IL NE FAIT L'OBJET D'AUCUN SUPPORT (en d'autres termes,
' je ne rpondrai  aucune question le concernant) NI D'AUCUNE GARANTIE
' D'AUCUNE SORTE. SI VOUS PERDEZ TOUTES VOS DONNEES,
' SI VOUS ETES LICENCIE OU SI VOS ENFANTS ET VOTRE CHIEN
' VOUS DETESTENT SUITE A SON USAGE, 
' C'EST VOTRE PROBLEME, PAS LE MIEN.

' History

' Version 1.01
' FEATURE Added title to msgBox

' Version 1.02 
' BUG Splitted test (previously linked by a AND) about drive ready and existing DCIM folder. Seems VBS does not warrant evaluation
'          order of clauses linked by a AND.

Option Explicit

Dim strComputer
Dim strDestinationPath           ' Folder where the pictures should go. Will be initialized from the first parameter passed to the script
Dim SourceDir                    ' Subfolders in the DCIM folder
Dim strSourcePath                ' Path of source files
Dim objWMIService
Dim colDisks                     ' Collection of disks of the system
Dim objDisk                      ' Each disk
Dim ColSourceFiles               ' List of files to copy from
Dim SourceFile                   ' Each file to copy from
Dim objFSO
Dim strDestFile                  'Filename of destination file
Dim bolAtLeastOneDestFileExists  ' Flag for managing ignored files warning
Dim intNumFilesCopied            ' Flag to avoid Pictures copied message if none were
Dim objArgs                      ' Parameters passed to the script
Dim strIgnoredFilesList          ' List of files that where not copied because they existed on the destination folder
Dim objDrive                     '  For testing if drive is ready else we get an error on multicards readers
Dim objDCIMDir                   ' Folders DCIM on the cards           
Dim objShell
Dim objMyPicFolder               ' Object on the "My pictures" folder

Const strDCIMDir = "\DCIM"       ' Name of the DCIM folder cameras create in the root of cards
Const MY_PICTURES = &H27&
Const strAUTOFOLDER = "\New Pictures"

strComputer = "."
Set objFSO = CreateObject("Scripting.FileSystemObject")
bolAtLeastOneDestFileExists = False
intNumFilesCopied = 0

set objArgs = wscript.arguments
if objArgs.count < 1 then
    ' If no destination folder is given, create a "New Pictures" folder in the "My Pictures" folder of the user
    Set objShell = CreateObject("Shell.Application")
    Set objMyPicFolder = objShell.Namespace(MY_PICTURES) 
    Set objMyPicFolder = objMyPicFolder.Self  
    strDestinationPath = objMyPicFolder.path & strAUTOFOLDER
    On error resume next    ' In case folder exists
        objFSO.CreateFolder(strDestinationPath)
    On error goto 0
else
    strDestinationPath = objArgs(0)
end if

if not objFSO.Folderexists(strDestinationPath) then
    msgBox "The destination folder does not exists. Copy aborted." & chr(13)_
        & "Usage: " & wscript.ScriptName & " Destination_folder.", vbCritical, "Error"
    wscript.quit 1
end if

Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\"_
        & strComputer & "\root\cimv2")
Set colDisks = objWMIService.ExecQuery ("Select * from Win32_LogicalDisk")
For Each objDisk in colDisks

    if objDisk.DriveType = 2  then   ' If removable
    
        ' Must test if it is ready because an empty but connected card reader would cause errors
        ' and must test if DCIM folder exists cause there might be non "camera" removable drives
        
        Set objDrive = objFSO.getDrive(objDisk.DeviceID)
        if objDrive.isReady Then        ' Should be tested first because it seems that the order of evaluation of AND clauses if not consistent
            If objFSO.Folderexists(objDisk.DeviceID & strDCIMDir) then 
                Set objDCIMDir = objFSO.getfolder (objDisk.DeviceID & strDCIMDir)    
                ' DeviceID is the logical disk name (D: for example)
                For Each SourceDir in objDCIMDir.subFolders
                
                    strSourcePath = objDisk.DeviceID & strDCIMDir & "\" & SourceDir.name
                    
                    Set ColSourceFiles = objWMIService.ExecQuery ("ASSOCIATORS OF {Win32_Directory.Name='"_
                        & strSourcePath & "'} Where ResultClass = CIM_DataFile")
                    For Each SourceFile In ColSourceFiles
                    
                        ' The name property gives the full (with path) file name and the filename property gives the bare file name

                            strDestFile = strDestinationPath & "\" & SourceFile.FileName _
                                & "." & SourceFile.extension
                            
                            If not objFSO.FileExists(strDestFile) Then
                                SourceFile.copy strDestFile, False
                                intNumFilesCopied = intNumFilesCopied + 1
                            Else
                                if bolAtLeastOneDestFileExists = False then
                                    bolAtLeastOneDestFileExists = True
                                    strIgnoredFilesList = SourceFile.Filename
                                Else
                                    strIgnoredFilesList = strIgnoredFilesList & ", " & SourceFile.Filename
                                End if
                            End If
                    Next
                
                Next
            End If  ' If has a DCIM folder
        End If      ' If isready 
    End if  ' If removable
Next
If bolAtLeastOneDestFileExists = True then
    msgbox Cstr(intNumFilesCopied) & " picture(s) copied to: " & chr(13) & strDestinationPath & "." & chr(13) &_
        "WARNING: Some files already existed in the destination folder. They were ignored."_
            & chr(13) & strIgnoredFilesList, vbExclamation, "Copy Photos"
else 
    msgbox Cstr(intNumFilesCopied) & " picture(s) copied to: " & chr(13) & strDestinationPath & ".", vbInformation, "Copy Photos"
End If

wscript.quit 0
